diff --git a/onmainwindow.cpp b/onmainwindow.cpp
index c9741f8..f973014 100644
--- a/onmainwindow.cpp
+++ b/onmainwindow.cpp
@@ -5062,17 +5152,14 @@ void ONMainWindow::slotTunnelOk(int)
     }
     if (dispInd == -1)
     {
-        x2goDebug << "No DISPLAY variable found in global environment, using autodetected setting.";
+
+        x2goDebug<< "No DISPLAY variable found in global environment, using autodetected setting.";
+
         env.append ("DISPLAY=" + disp);
     }
 #endif
     nxproxy->setEnvironment ( env );
-    /*	x2goDebug<<"new env:"<<endl;
-    	for ( int l=0;l<env.size();++l )
-    	{
-    		x2goDebug<<env[l]<<endl;
-    	}
-    	x2goDebug<<"##########################"<<endl;*/
+
     connect ( nxproxy,SIGNAL ( error ( QProcess::ProcessError ) ),this,
               SLOT ( slotProxyError ( QProcess::ProcessError ) ) );
     connect ( nxproxy,SIGNAL ( finished ( int,QProcess::ExitStatus ) ),this,
@@ -5091,7 +5178,9 @@ void ONMainWindow::slotTunnelOk(int)
     dir.cd ( "exe" );
     proxyCmd="\""+dir.absolutePath() +"/\""+proxyCmd;
 #endif //Q_OS_DARWIN
-    x2goDebug<<"starting nxproxy with: "<<proxyCmd<<endl;
+
+    x2goDebug<<"Starting NX proxy, command: " + proxyCmd;
+
     nxproxy->start ( proxyCmd );
     proxyRunning=true;
 //always search for proxyWin
@@ -5212,7 +5301,8 @@ void ONMainWindow::slotProxyFinished ( int,QProcess::ExitStatus )
     if ( spoolTimer )
         delete spoolTimer;
 
-    x2goDebug<<"deleting proxy"<<endl;
+    x2goDebug<<"Deleting Proxy." ;
+
     disconnect ( nxproxy,SIGNAL ( error ( QProcess::ProcessError ) ),this,
                  SLOT ( slotProxyError ( QProcess::ProcessError ) ) );
     disconnect ( nxproxy,SIGNAL ( finished ( int,QProcess::ExitStatus ) ),this,
@@ -5237,7 +5327,7 @@ void ONMainWindow::slotProxyFinished ( int,QProcess::ExitStatus )
     if(proxyErrString.indexOf("No data received from remote proxy")!=-1)
     {
         emergencyExit=true;
-        x2goDebug<<"Emergency exit"<<endl;
+        x2goWarningf(4)<< tr( "Emergency exit." );
     }
 
 #if ! (defined (CFGPLUGIN))
@@ -5246,21 +5336,22 @@ void ONMainWindow::slotProxyFinished ( int,QProcess::ExitStatus )
         if ( nxproxy->state() ==QProcess::Running )
         {
             emergencyExit=true;
-            x2goDebug<<"waiting for proxy to exit"<<endl;
+            x2goWarningf(5)<< tr( "Waiting for proxy to exit." );
             if ( !nxproxy->waitForFinished ( 3000 ) )
             {
-                x2goDebug<<"Failed, try to kill"<<endl;
+                x2goWarningf(6)<< tr( "Failed, killing the proxy." );
                 nxproxy->kill();
             }
         }
-        x2goDebug<<"nxproxy not running"<<endl;
+
 #ifdef Q_OS_LINUX
         if (directRDP)
             nxproxy=0;
 #endif
     }
 #endif
-    x2goDebug<<"proxy deleted"<<endl;
+    x2goDebug<<"Waiting for proxy to exit.";
+
     spoolTimer=0l;
     tunnel=sndTunnel=fsTunnel=0l;
     soundServer=0l;
@@ -5279,14 +5370,14 @@ void ONMainWindow::slotProxyFinished ( int,QProcess::ExitStatus )
     if ( !emergencyExit && !shadowSession && !usePGPCard && ! ( embedMode &&
             ( config.checkexitstatus==false ) ) )
     {
-        x2goDebug<<"checking exit status";
+        x2goDebug<<"Checking exit status.";
         check_cmd_status();
     }
     else
     {
-        x2goDebug<<"deleting sshConnection instance: "<<endl;
+        x2goDebug<<"Deleting SSH connection instance.";
         delete sshConnection;
-        x2goDebug<<"done"<<endl;
+        x2goDebug<<"Deleted  SSH connection instance." ;
         sshConnection=0;
     }
     if ( startHidden )
@@ -5324,6 +5415,7 @@ void ONMainWindow::slotProxyFinished ( int,QProcess::ExitStatus )
         sessionStatusDlg->hide();
         resumeSession ( resumingSession );
     }
+    x2goDebug<<"Finished Proxy.";
     setStatStatus ( tr ( "Finished" ) );
 }
 
@@ -5334,7 +5426,9 @@ void ONMainWindow::slotProxyStderr()
     if ( nxproxy )
         reserr= nxproxy->readAllStandardError();
     proxyErrString+=reserr;
-    x2goDebug<<reserr<<endl;
+
+    x2goDebug<<"Proxy wrote on stderr: "<<reserr;
+
     stInfo->insertPlainText ( reserr );
     stInfo->ensureCursorVisible();
     if ( stInfo->toPlainText().indexOf (
@@ -5421,7 +5515,9 @@ void ONMainWindow::slotProxyStderr()
 #if defined( Q_OS_WIN ) && defined (CFGPLUGIN)
     if ( reserr.indexOf ( "Session terminated at" ) !=-1 )
     {
-        x2goDebug<<"proxy finished"<<endl;
+
+        x2goDebug<<"Proxy finished.";
+
         slotProxyFinished ( 0, QProcess::NormalExit );
     }
 #endif
@@ -5433,8 +5529,8 @@ void ONMainWindow::slotProxyStderr()
 void ONMainWindow::slotProxyStdout()
 {
     QString resout ( nxproxy->readAllStandardOutput() );
-    x2goDebug<<resout<<endl;
 
+    x2goDebug<<"Proxy wrote on stdout: "<<resout;
 }
 
 
@@ -5588,7 +5684,7 @@ bool ONMainWindow::termSession ( QString sessId, bool warn )
         nxproxy->terminate();
         return true;
     }
-
+    x2goDebug<<"Terminating session.";
     sshConnection->executeCommand ( "x2goterminate-session "+sessId, this, SLOT ( slotRetTermSess ( bool,
                                     QString,int) )  );
     proxyRunning=false;
@@ -5970,13 +6066,15 @@ void ONMainWindow::slotReadApplications(bool result, QString output,
             if (line.indexOf("Name["+localshort+"]=")!=-1  || line.indexOf("Name["+locallong+"]=")!=-1)
             {
                 app.name=QString::fromUtf8(line.split("=")[1].toAscii());
-//                 x2goDebug<<"local name: "<<app.name<<endl;
+
+                //                 x2goDebug<<"local name: "<<app.name<<endl;
+
                 localname=true;
             }
             if (line.indexOf("Comment["+localshort+"]=")!=-1 || line.indexOf("Comment["+locallong+"]=")!=-1)
             {
                 app.comment=QString::fromUtf8(line.split("=")[1].toAscii());
-//                 x2goDebug<<"local comment: "<<app.comment<<endl;
+                //                 x2goDebug<<"local comment: "<<app.comment<<endl;
                 localcomment=true;
             }
             if (line.indexOf("Name=")!=-1 && !localname)
@@ -5984,12 +6082,12 @@ void ONMainWindow::slotReadApplications(bool result, QString output,
                 app.name=line.split("=")[1];
                 if (app.name==autostartApp)
                     startAppFound=true;
-//                 x2goDebug<<"name: "<<app.name<<endl;
+                //                 x2goDebug<<"name: "<<app.name<<endl;
             }
             if (line.indexOf("Comment=")!=-1 && !localcomment)
             {
                 app.comment=line.split("=")[1];
-//                 x2goDebug<<"comment: "<<app.comment<<endl;
+                //                 x2goDebug<<"comment: "<<app.comment<<endl;
             }
             if (line.indexOf("Exec=")!=-1)
             {
@@ -6000,7 +6098,7 @@ void ONMainWindow::slotReadApplications(bool result, QString output,
                 app.exec.replace("%u","",Qt::CaseInsensitive);
                 if (app.exec==autostartApp)
                     startAppFound=true;
-//                 x2goDebug<<"exec: "<<app.exec<<endl;
+                //                 x2goDebug<<"exec: "<<app.exec<<endl;
             }
             if (line.indexOf("Categories=")!=-1)
             {
@@ -6067,10 +6165,13 @@ void ONMainWindow::slotReadApplications(bool result, QString output,
     plugAppsInTray();
     if (runStartApp && autostartApp.length()>1)
     {
-        if (!startAppFound)
-            x2goDebug<<"Autostart application "<<autostartApp<< " not found in Desktop files"<<endl;
+        if (!startAppFound) {
+            x2goDebug<<"Autostart application "<<autostartApp<< " not found in Desktop files.";
+        }
         else
+        {
             runApplication(autostartApp);
+        }
     }
 }
 
@@ -6089,6 +6190,12 @@ bool ONMainWindow::parseParameter ( QString param )
         return false;
     }
 
+    if (param == "--debug")
+    {
+        ONMainWindow::debugging = true;
+        return true;
+    }
+
     if ( param == "--portable" )
     {
         ONMainWindow::portable=true;
@@ -6403,10 +6510,11 @@ bool ONMainWindow::parseParameter ( QString param )
         if (find!=-1 && lind !=-1)
         {
             QString label=value.mid(find+1,lind-find-1);
-            x2goDebug<< "searching for drive with label: "<<label;
+            x2goDebug<<"Searching for drive with label: "<<label;
+
             QString drive=wapiGetDriveByLabel(label);
             value.replace("("+label+")",drive);
-            x2goDebug<<"new path: "<<value;
+            x2goDebug<<"New path: "<<value;
         }
 #endif
         if (! dr.exists(value))
@@ -6623,11 +6731,15 @@ bool ONMainWindow::packParameter ( QString val )
 
 void ONMainWindow::printError ( QString param )
 {
-    qCritical ( "%s", ( tr ( "wrong parameter: " ) +param ).
-                toLocal8Bit().data() );
-#ifdef Q_OS_WIN
-    x2goDebug<<tr ( "wrong parameter: " ) +param <<endl;
-#endif
+    if( !startHidden )
+    {
+        qCritical ( "%s", ( tr ( "Wrong parameter: " ) +param ).
+                    toLocal8Bit().data() );
+    }
+    else
+    {
+        x2goErrorf(8)<<tr("Wrong parameter: ")<<param;
+    }
 }
 
 void ONMainWindow::showHelp()
@@ -6637,6 +6749,7 @@ void ONMainWindow::showHelp()
         "Options:\n"
         "--help\t\t\t\t show this message\n"
         "--help-pack\t\t\t show available pack methods\n"
+        "--debug\t\t\t\t enables extensive output for console output.\n"
         "--no-menu\t\t\t hide menu bar\n"
         "--no-session-edit\t\t not allow user to edit preconfigured\n"
         "\t\t\t\t sessions\n"
@@ -6661,7 +6774,7 @@ void ONMainWindow::showHelp()
         "--command=<cmd>\t\t\t Set default command, default value 'KDE'\n"
         "--session=<session>\t\t Start session 'session'\n"
         "--user=<username>\t\t select user 'username'\n"
-        "--geomerty=<W>x<H>|fullscreen\t set default geometry, default "
+        "--geometry=<W>x<H>|fullscreen\t set default geometry, default "
         "value '800x600'\n"
         "--dpi=<dpi>\t\t\t set dpi of x2goagent to dpi, default not set\n"
         "--link=<modem|isdn|adsl|wan|lan> set default link type, "
@@ -6677,7 +6790,10 @@ void ONMainWindow::showHelp()
         "applications\" mode\n"
         "--session-conf=<file>\t\t path to alternative session config\n";
     qCritical ( "%s",helpMsg.toLocal8Bit().data() );
-    QMessageBox::information ( this,tr ( "Options" ),helpMsg );
+    if (!startHidden)
+    {
+        QMessageBox::information ( this,tr ( "Options" ),helpMsg );
+    }
 }
 
 void ONMainWindow::showHelpPack()
@@ -6749,10 +6865,12 @@ void ONMainWindow::slotGetServers ( bool result, QString output,
                     x2goServers[j].sess=
                         lst[1].toInt() *
                         x2goServers[j].factor;
+
                     x2goDebug<<x2goServers[j].name<<
                              ": sessions "<<
                              lst[1].toInt() <<
                              ", multiplied "<<x2goServers[j].sess;
+
                     break;
                 }
         }
@@ -6826,22 +6944,26 @@ void ONMainWindow::slotListAllSessions ( bool result,QString output,
                 ( listedSessions.size() ==1 &&
                   listedSessions[0].length() <5 ) )
         {
-// 	x2goDebug<<"start New Session";
+            x2goDebug<<"Start new session.";
             startNewSession();
         }
         else if ( listedSessions.size() ==1 )
         {
-// 	x2goDebug<<"have one session";
+            x2goDebug<<"Already having a session.";
             x2goSession s=getSessionFromString (
                               listedSessions[0] );
-// 		x2goDebug<<"will procceed one session";
+
+            x2goDebug<<"Will procceed with session.";
+
             QDesktopWidget wd;
             if ( s.status=="S" && isColorDepthOk (
                         wd.depth(),s.colorDepth ) )
+            {
                 resumeSession ( s );
+            }
             else
             {
-// 				x2goDebug<<"select one Session";
+                x2goDebug<<"Please select one session...";
                 selectSession ( listedSessions );
             }
         }
@@ -6926,7 +7048,8 @@ void ONMainWindow::exportDirs ( QString exports,bool removable )
     dr.dirList=exports;
     dr.key=createRSAKey();
     QString passwd;
-    x2goDebug<<"key created on: "<<dr.key;
+
+    x2goDebug<<"Key created on: "<<dr.key;
 
     passwd=getCurrentPass();
 
@@ -7093,15 +7216,17 @@ QString ONMainWindow::createRSAKey()
 
     QStringList args;
 
-    args<<"-t"<<"rsa"<<"-b"<<"1024"<<"-N"<<""<<"-f"<<keyName;
-// 	x2goDebug <<keyName<<endl;
+    args<<"-t"<<"rsa"<<"-b"<<"1024"<<"-N"<<""<<"-f"<<keyName<<"-q";
+
+    x2goDebug<<"ssh-keygen " + args.join(" ");
 
     if ( QProcess::execute ( "ssh-keygen",args ) !=0 )
     {
-        x2goDebug <<"ssh-keygen failed" <<endl;
+        x2goDebug<<"ssh-keygen failed." <<endl;
         return QString::null;
     }
-// 	x2goDebug <<"ssh-keygen ok" <<endl;
+    x2goDebug<<"ssh-keygen succeeded.";
+
 
     QFile rsa ( "/etc/ssh/ssh_host_rsa_key.pub" );
 #ifdef Q_OS_WIN
@@ -7137,7 +7262,7 @@ QString ONMainWindow::createRSAKey()
         rsa_pub = rsa.readLine();
     else
     {
-        x2goDebug<<"error: rsa file empty";
+        x2goErrorf(9)<<tr("RSA file empty.");
         return QString::null;
     }
 
@@ -7146,7 +7271,7 @@ QString ONMainWindow::createRSAKey()
                 QIODevice::WriteOnly | QIODevice::Text | QIODevice::Append )
        )
     {
-        x2goDebug<<"error openning key:"<<keyName;
+        x2goErrorf(10)<<tr("Can not open key: ")<<keyName;
         return keyName;
     }
     QTextStream out ( &file );
@@ -7158,9 +7283,12 @@ QString ONMainWindow::createRSAKey()
 void ONMainWindow::slotCopyKey ( bool result, QString output, int pid)
 {
     fsExportKey=sshConnection->getSourceFile(pid);
-    x2goDebug<<"exported key "<<fsExportKey;
+
+    x2goDebug<<"Exported key: "<<fsExportKey;
+
     QFile::remove ( fsExportKey );
-    x2goDebug<<"key removed";
+    x2goDebug<<"Key removed.";
+
     if ( result==false )
     {
         QString message=tr ( "<b>Connection failed</b>\n" ) +output;
@@ -7170,9 +7298,23 @@ void ONMainWindow::slotCopyKey ( bool result, QString output, int pid)
                     message;
         }
 
-        QMessageBox::critical ( 0l,tr ( "Error" ),message,
-                                QMessageBox::Ok,
-                                QMessageBox::NoButton );
+        if (!startHidden)
+        {
+            QMessageBox::critical ( 0l,tr ( "Error" ),message,
+                                    QMessageBox::Ok,
+                                    QMessageBox::NoButton );
+        }
+        else
+        {
+            QString printout = tr( "Connection failed: ")  + output.toAscii();
+
+            if ( output.indexOf ( "publickey,password" ) !=-1 )
+                x2goErrorf(11)<< tr( "Connection failed: ")  + output + tr(" - Wrong password.");
+            else
+                x2goErrorf(12)<< tr( "Connection failed: ")  + output;
+            trayQuit();
+        }
+
         QFile::remove ( fsExportKey+".pub" );
         return;
     }
@@ -7240,7 +7382,9 @@ void ONMainWindow::slotRetExportDir ( bool result,QString output,
 #ifdef Q_OS_WIN
     QDir dir;
     dir.mkpath ( authofname+"\\.x2go\\.ssh" );
-    x2goDebug<<"Creating "<<authofname+"\\.x2go\\.ssh"<<endl;
+
+    x2goDebug<<"Creating "<<authofname+"\\.x2go\\.ssh";
+
     authofname=wapiShortFileName ( authofname ) +"/.x2go";
 #endif
     authofname+="/.ssh/authorized_keys" ;
@@ -7296,13 +7440,15 @@ void ONMainWindow::slotExtTimer()
             ( QFile::ReadUser|QFile::WriteUser|QFile::ExeUser|
               QFile::ReadOwner|QFile::WriteOwner|QFile::ExeOwner ) )
     {
-        x2goDebug <<"Wrong permissions on "<<readLoginsFrom <<":"<<endl;
-        x2goDebug << ( int ) ( QFile::permissions (
+
+        x2goDebug<<"Wrong permissions on "<<readLoginsFrom <<":";
+        x2goDebug<< ( int ) ( QFile::permissions (
                                    readLoginsFrom+"/." ) )
                   <<"must be"<< ( int ) ( QFile::ReadUser|QFile::WriteUser
                                           |QFile::ExeUser|QFile::ReadOwner|
                                           QFile::WriteOwner|
                                           QFile::ExeOwner ) <<endl;
+
         if ( extLogin )
             extTimer->stop();
         return;
@@ -7332,9 +7478,9 @@ void ONMainWindow::slotExtTimer()
                 }
                 if ( args[0]=="logout" )
                 {
-                    x2goDebug <<
-                              " I HAVE external logout"<<
-                              endl;
+
+                    x2goDebug<<"External logout.";
+
                     args[1].replace ( "\n","" );
                     if ( args[1].size() )
                         logoutDir=args[1];
@@ -7348,7 +7494,7 @@ void ONMainWindow::slotExtTimer()
     {
         if ( logoutDir != QString::null )
         {
-            x2goDebug <<"external logout"<<endl;
+            x2goDebug<<"External logout received";
             externalLogout ( logoutDir );
         }
     }
@@ -7356,7 +7502,7 @@ void ONMainWindow::slotExtTimer()
     {
         if ( loginDir != QString::null )
         {
-            x2goDebug <<"external login"<<endl;
+            x2goDebug<<"External login.";
             externalLogin ( loginDir );
         }
     }
@@ -7371,9 +7517,10 @@ void ONMainWindow::slotExportTimer()
             QFile::ExeUser|
             QFile::ReadOwner|QFile::WriteOwner|QFile::ExeOwner ) )
     {
-        x2goDebug <<"Wrong permissions on "<<
+
+        x2goDebug<<"Wrong permissions on "<<
                   readExportsFrom <<":"<<endl;
-        x2goDebug << ( int ) ( QFile::permissions (
+        x2goDebug<< ( int ) ( QFile::permissions (
                                    readExportsFrom+"/." ) )
                   <<"must be"<< ( int ) ( QFile::ReadUser|QFile::WriteUser
                                           |QFile::ExeUser|QFile::ReadOwner|
@@ -7707,7 +7854,9 @@ void ONMainWindow::slotScDaemonError()
 {
     QString stdOut ( scDaemon->readAllStandardError() );
     stdOut=stdOut.simplified();
-    x2goDebug<<"SCDAEMON err:"<<stdOut<<endl;
+
+    x2goDebug<<"SCDAEMON error: "<<stdOut;
+
     if ( stdOut.indexOf ( "updating slot" ) !=-1 ||
             stdOut.indexOf ( "updating status of slot" ) !=-1 )
     {
@@ -7725,7 +7874,8 @@ void ONMainWindow::slotScDaemonOut()
 {
     QString stdOut ( scDaemon->readAllStandardOutput() );
     stdOut=stdOut.simplified();
-    x2goDebug<<"SCDAEMON out:"<<stdOut<<endl;
+
+    x2goDebug<<"SCDAEMON out: "<<stdOut;
 }
 
 void ONMainWindow::slotScDaemonFinished ( int , QProcess::ExitStatus )
@@ -7733,7 +7883,9 @@ void ONMainWindow::slotScDaemonFinished ( int , QProcess::ExitStatus )
     scDaemon=0l;
     if ( isScDaemonOk )
     {
-        x2goDebug<<"scDaemon finished"<<endl;
+
+        x2goDebug<<"SCDAEMON finished."<<endl;
+
         gpg=new QProcess ( this );
         QStringList arguments;
         arguments<<"--card-status";
@@ -7755,7 +7907,9 @@ void ONMainWindow::slotGpgError()
 {
     QString stdOut ( gpg->readAllStandardError() );
     stdOut=stdOut.simplified();
-    x2goDebug<<"GPG err:"<<stdOut<<endl;
+
+    x2goDebug<<"GPG error: "<<stdOut;
+
     if ( stdOut.indexOf ( "failed" ) !=-1 )
     {
         QMessageBox::critical ( 0l,tr ( "Error" ),
@@ -7770,13 +7924,17 @@ void ONMainWindow::slotGpgError()
 void ONMainWindow::slotGpgFinished ( int exitCode,
                                      QProcess::ExitStatus exitStatus )
 {
-    x2goDebug<<"gpg finished, exit code:"<<exitCode<<" exit status:"<<
-             exitStatus<<endl;
+
+    x2goDebug<<"GPG finished, exit code: "<<exitCode;
+    x2goDebug<<"GPG finished, exit status:"<<exitStatus;
+
     if ( exitStatus==0 )
     {
         QString stdOut ( gpg->readAllStandardOutput() );
         stdOut.chop ( 1 );
-        x2goDebug<<"GPG out:"<<stdOut<<endl;
+
+        x2goDebug<<"GPG out: "<<stdOut;
+
         QStringList lines=stdOut.split ( "\n" );
         QString login;
         QString appId;
@@ -7801,10 +7959,14 @@ void ONMainWindow::slotGpgFinished ( int exitCode,
         appId=appId.simplified();
         login=login.simplified();
         authKey=authKey.simplified();
-        x2goDebug<<"card data: "<<appId<<login<<authKey<<endl;
+
+        x2goDebug<<"Card data: "<<appId<<login<<authKey;
+
         if ( login=="[not set]" || authKey == "[none]" )
         {
-            x2goDebug<<"Card not configured\n";
+
+            x2goErrorf(13)<<tr("Card not configured.");
+
             QMessageBox::critical (
                 0l,tr ( "Error" ),
                 tr (
@@ -7880,15 +8042,16 @@ void ONMainWindow::slotGpgAgentFinished ( int , QProcess::ExitStatus )
     QString gpg_agent_info=envLst[0].split ( "=" ) [1];
     QString ssh_auth_sock=envLst[2].split ( "=" ) [1];
     agentPid=envLst[4].split ( "=" ) [1];
-    x2goDebug<<gpg_agent_info<<ssh_auth_sock<<agentPid<<endl;
-    x2goDebug<<"GPGAGENT out:"<<envLst[0]<<envLst[2]<<envLst[4]<<endl;
+
+    x2goDebug<<"GPG-agent info: "<<gpg_agent_info<<ssh_auth_sock<<agentPid;
+    x2goDebug<<"GPG-agent pid: "<<agentPid;
+    x2goDebug<<"GPG-agent out:"<<envLst[0]<<envLst[2]<<envLst[4];
 
     agentCheckTimer->start ( 1000 );
     cardReady=true;
 
     sshEnv.clear();
     sshEnv<<envLst[0]<<envLst[2]<<envLst[4];
-// 	x2goDebug<<"sshenv:"<<sshEnv<<endl;
 
     if ( !useLdap )
     {
@@ -7912,7 +8075,9 @@ void ONMainWindow::slotGpgAgentFinished ( int , QProcess::ExitStatus )
         sshadd.waitForFinished ( -1 );
         QString sshout ( sshadd.readAllStandardOutput() );
         sshout=sshout.simplified();
-        x2goDebug<<"SSH-ADD out:"<<sshout<<endl;
+
+        x2goDebug<<"SSH-ADD out: "<<sshout;
+
         if(brokerMode)
         {
             broker->getUserSessions();
@@ -7931,7 +8096,9 @@ void ONMainWindow::slotGpgAgentFinished ( int , QProcess::ExitStatus )
             sshadd.waitForFinished ( -1 );
             QString sshout ( sshadd.readAllStandardOutput() );
             sshout=sshout.simplified();
-            x2goDebug<<"SSH-ADD out:"<<sshout<<endl;
+
+            x2goDebug<<"SSH-ADD out: "<<sshout;
+
             return;
         }
 
@@ -7956,13 +8123,14 @@ void ONMainWindow::slotCheckAgentProcess()
         if ( nxproxy )
             if ( nxproxy->state() ==QProcess::Running )
             {
-                x2goDebug<<"Suspending session\n";
+                x2goDebug<<"Suspending session...";
                 slotSuspendSessFromSt();
+                x2goDebug<<"Suspended  session.";
 //                 nxproxy->terminate();
             }
     }
 
-    x2goDebug<<"gpg-agent finished\n";
+    x2goDebug<<"GPG-Agent finished.";
     slotStartPGPAuth();
 }
 
@@ -7992,7 +8160,9 @@ QString ONMainWindow::getXDisplay()
         // Mac OS X 10.4 compatibility mode.
         // There, it is possible no $DISPLAY variable is set.
         // Start X11 manually. First, find a free display number.
-        x2goDebug << "entering 10.4 compat mode, checking for free X11 display";
+
+        x2goDebug<< "entering 10.4 compat mode, checking for free X11 display";
+
 
         int xFreeDisp = 0;
         QDir xtmpdir ("/tmp/.X11-unix");
@@ -8022,7 +8192,8 @@ QString ONMainWindow::getXDisplay()
         if (xFreeDisp != -1)
         {
             xsocket = "/tmp/.X11-unix/X" + QString::number (xFreeDisp);
-            x2goDebug << "Successfully detected free socket " << xsocket << ".";
+
+            x2goDebug<< "Successfully detected free socket " << xsocket << ".";
         }
 
         if (!(xsocket.isEmpty ()))
@@ -8032,18 +8203,21 @@ QString ONMainWindow::getXDisplay()
             QProcessEnvironment env = QProcessEnvironment::systemEnvironment ();
             QProcess* startx = new QProcess (this);
 
-            x2goDebug << "Starting the X server on free display port.";
+            x2goDebug<< "Starting the X server on free display port.";
+
             env.insert (0, "PATH=/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/X11R6/bin");
 
             startx->setProcessEnvironment (env);
             startx->start (xname + QString (" ") + xopt, QIODevice::NotOpen);
             if (startx->waitForStarted (3000))
             {
-                x2goDebug << "sleeping for three seconds";
+
+                x2goDebug<< "Sleeping for three seconds";
                 int sleeptime = 3;
                 while ((sleeptime = sleep (sleeptime))) {};
 
-                x2goDebug << "Leaving OS X 10.4 compat mode.";
+                x2goDebug<< "Leaving OS X 10.4 compat mode.";
+
             }
         }
     }
@@ -8071,7 +8245,9 @@ QString ONMainWindow::getXDisplay()
             }
             // Prepend the well-known socket path.
             xsocket.prepend ("/tmp/.X11-unix/X");
-            x2goDebug << "xsocket in compat mode: " << xsocket;
+
+            x2goDebug<< "xsocket in compat mode: " << xsocket;
+
         }
 
         unixSocket.connectToServer (xsocket);
@@ -8096,7 +8272,7 @@ QString ONMainWindow::getXDisplay()
 
                 if (ok)
                 {
-                    x2goDebug << "Returning" << QString (":") + xsocket;
+                    x2goDebug<<"Returning " << QString (":") + xsocket;
                     return (QString (":") + xsocket);
                 }
             }
@@ -8222,7 +8398,9 @@ void ONMainWindow::slotExecXmodmap()
 //  	    "echo add mod5 = ISO_Level3_Shift"
         ")| DISPLAY=:"
         +resumingSession.display+" xmodmap - ";
-    x2goDebug<<"cmd:"<<cmd;
+
+    x2goDebug<<"Executing xmodmap with cmd: "<<cmd;
+
     SshProcess* xmodProc;
     try
     {
@@ -8248,7 +8426,11 @@ void ONMainWindow::slotExecXmodmap()
 
 void ONMainWindow::check_cmd_status()
 {
-    x2goDebug<<"check command message"<<endl;
+    QString passwd;
+    QString user=getCurrentUname();
+    QString host=resumingSession.server;
+    passwd=getCurrentPass();
+
     sshConnection->executeCommand ( "x2gocmdexitmessage "+
                                     resumingSession.sessionId , this, SLOT(slotCmdMessage(bool, QString, int)));
 }
@@ -8256,6 +8438,7 @@ void ONMainWindow::check_cmd_status()
 void ONMainWindow::slotCmdMessage ( bool result,QString output,
                                     int)
 {
+    x2goDebug<<"Command Message: " + output;
     if ( result==false )
     {
         cardReady=false;
@@ -8282,10 +8465,18 @@ void ONMainWindow::slotCmdMessage ( bool result,QString output,
     {
         QString cmd=output;
         cmd.replace ( "X2GORUNCOMMAND ERR NOEXEC:","" );
-        QMessageBox::critical ( 0l,tr ( "Error" ),
-                                tr ( "Unable to execute: " ) +
-                                cmd,QMessageBox::Ok,
-                                QMessageBox::NoButton );
+
+        if(startHidden)
+        {
+            x2goErrorf(14)<< tr( "Unable to execute: ") + cmd;
+        }
+        else
+        {
+            QMessageBox::critical ( 0l,tr ( "Error" ),
+                                    tr ( "Unable to execute: " ) +
+                                    cmd,QMessageBox::Ok,
+                                    QMessageBox::NoButton );
+        }
     }
     delete sshConnection;
     sshConnection=0;
@@ -8295,8 +8486,10 @@ void ONMainWindow::slotCmdMessage ( bool result,QString output,
 int ONMainWindow::startSshFsTunnel()
 {
     fsTunReady=false;
-    x2goDebug<<"starting fs tunnel for:"<<resumingSession.sessionId<<
-             "\nfs port: "<<resumingSession.fsPort;
+
+    x2goDebug<<"Starting fs tunnel for: "<<resumingSession.sessionId;
+    x2goDebug<<"fs port: "<<resumingSession.fsPort;
+
 
     if ( resumingSession.fsPort.length() <=0 )
     {
@@ -8368,7 +8561,9 @@ void ONMainWindow::startX2goMount()
 #ifdef Q_OS_WIN
     QDir tdir;
     tdir.mkpath ( authofname+"\\.x2go\\.ssh" );
-    x2goDebug<<"Creating "<<authofname+"\\.x2go\\.ssh"<<endl;
+
+    x2goDebug<<"Creating "<<authofname+"\\.x2go\\.ssh";
+
     authofname=wapiShortFileName ( authofname ) +"/.x2go";
 #endif
     authofname+= "/.ssh/authorized_keys" ;
@@ -8488,7 +8683,6 @@ void ONMainWindow::startX2goMount()
 
     dir->pid=sshConnection->executeCommand(cmd,this,SLOT ( slotRetExportDir ( bool,
                                            QString,int) ));
-
 }
 
 void ONMainWindow::slotCheckPrintSpool()
@@ -8574,14 +8768,18 @@ bool ONMainWindow::isServerRunning ( int port )
     iResult = WSAStartup(MAKEWORD(2, 2), &wsaData);
     if (iResult != 0)
     {
-        x2goDebug<<"WARNING: WSAStartup failed: "<< iResult<<endl;
+
+        x2goDebug<<"WARNING: WSAStartup failed: "<< iResult;
+
         return false;
     }
 
     addr.s_addr = inet_addr("127.0.0.1");
     if (addr.s_addr == INADDR_NONE)
     {
+
         x2goDebug<< "WARNING:  The IPv4 address entered must be a legal address\n";
+
         return false;
     }
 
@@ -8589,10 +8787,13 @@ bool ONMainWindow::isServerRunning ( int port )
     localHost = gethostbyaddr((char*)&addr,4, AF_INET);
     if (!localHost)
     {
-        x2goDebug<<"WARNING: gethostbyaddr failed: "<<WSAGetLastError()<<endl;
+
+        x2goDebug<<"WARNING: gethostbyaddr failed: "<<WSAGetLastError();
+
         return false;
     }
-    x2goDebug<<"got localhost"<<endl;
+    x2goDebug<<"got localhost";
+
 
     localIP = inet_ntoa (*(struct in_addr *)*localHost->h_addr_list);
 
@@ -8603,7 +8804,8 @@ bool ONMainWindow::isServerRunning ( int port )
     ConnectSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
     if (ConnectSocket == INVALID_SOCKET)
     {
-        x2goDebug<<"WARNING: socket failed with error: "<< WSAGetLastError()<<endl;
+        x2goDebug<<"WARNING: socket failed with error: "<< WSAGetLastError();
+
         return false;
     }
 
@@ -8611,11 +8813,15 @@ bool ONMainWindow::isServerRunning ( int port )
     if (iResult == SOCKET_ERROR)
     {
         closesocket(ConnectSocket);
-        x2goDebug<<"Port is free: "<<port<<endl;
+
+        x2goDebug<<"Port is free: "<<port;
+
         return false;
     }
     closesocket(ConnectSocket);
-    x2goDebug<<"Port already used: "<<port<<endl;
+
+    x2goDebug<<"Port already used: "<<port;
+
     return true;
 #endif
     QTcpSocket tcpSocket ( 0 );
@@ -8673,7 +8879,9 @@ void ONMainWindow::startXOrg ()
     if (internalX==VCXSRV)
         exec=appDir+"\\vcxsrv\\vcxsrv.exe";
     winServersReady=false;
+
     x2goDebug<<"using internal X: "<<useInternalX;
+
 //#ifdef CFGCLIENT
     if (!useInternalX || internalX!=XMING)
     {
@@ -8694,10 +8902,13 @@ void ONMainWindow::startXOrg ()
                 break;
             case WIN:
                 cmdLine=xorgWinOptions;
-                x2goDebug<<"WxH:"<<xorgWidth<<"x"<<xorgHeight<<endl;
+
+                x2goDebug<<"WxH:"<<xorgWidth<<"x"<<xorgHeight;
+
                 cmdLine.replace("%w",xorgWidth);
                 cmdLine.replace("%h",xorgHeight);
-                x2goDebug<<cmdLine<<endl;
+
+                x2goDebug<<cmdLine;
                 break;
             }
         }
@@ -8733,7 +8944,9 @@ void ONMainWindow::startXOrg ()
         xorg-> setWorkingDirectory ( workingDir);
     }
 
-    x2goDebug<<"running"<<exec<<" "<<args.join(" ");
+
+    x2goDebug<<"Running "<<exec<<" "<<args.join(" ");
+
     xorg->start ( exec, args );
 
 
@@ -8760,7 +8973,9 @@ void ONMainWindow::slotCheckXOrgConnection()
     ++waitingForX;
     if (isServerRunning(6000+xDisplay))
     {
-        x2goDebug<<"X is started";
+
+        x2goDebug<<"X is started.";
+
         slotSetWinServersReady();
     }
     else
